#! /usr/bin/env python3
# -*- coding: utf-8 -*-
import csv
import sys
import shutil
from os import getcwd, chdir, path
rep_cour = getcwd()
chdir(rep_cour)
#print('repertoire courant getcwd ', rep_cour)
dir_path = path.dirname(path.abspath(__file__))
#print('dir path ', dir_path)
import inspect
repertoire_script = path.realpath(path.abspath(path.split(inspect.getfile( inspect.currentframe() ))[0]))
#print ('chemin ', repertoire_script)
if sys.version[0] == '3':
    from tkinter import *
else:
    from Tkinter import *
from random import randrange
listeCouleur = ['red', 'yellow', 'magenta', 'lightblue', 'blue', 'green', 'orange', 'white']
nomCouleur = ['rouge', 'jaune', 'violet', 'bleu clair', 'bleu', 'vert', 'orange', 'blanc']
listeAffichage = ['choix1', 'choix2', 'choix3', 'choix4',
    'choix5', 'choix6', 'choix7', 'choix8', 'choix9', 'choix10']

mafonte = "Arial 14 bold"
#Crée une copie de sauvegarde du fichier des noms et du score
fic_score = path.join(repertoire_script, 'ScoreMastermind.csv')
fic_scoreOld = path.join(repertoire_script, 'ScoreMastermindOld.csv')
fic_image = path.join(repertoire_script, 'mastermind2.gif')
#print (fic_score)
shutil.copy2(fic_score, fic_scoreOld)


def cercle(can, x, y, r, coul, montag=""):
    "tracé d'un cercle de centre (x,y) et de rayon r"
    can.create_oval(x - r, y - r, x + r, y + r, fill=coul, tags=montag)


class Plateau(Frame):
    def __init__(self, joueur):
        Frame.__init__(self)
        self.joueur = joueur  # nom du joueur envoyé par le menu
        self.grid()
        self.configure(bg='#b69f93')
        self.frameGauche = Frame(self, width=220, height=750, bd=3, bg='#866752', relief=RIDGE)

        self.frameGauche.grid(row=1, column=0)
        self.frameGauche.grid_propagate(0)

        self.nombreVerif = 0  # augmente de 1 à chaque vérification,
        #sert d'index pour afficher dans le canevas correspondant

        #cadre et etiquettes des scores:
        #ouvre le fichier avec les noms et score
        with open(fic_score, 'r', newline='') as fichier1:
            lire = csv.reader(fichier1, delimiter=';')
            for ligne in lire:
                if ligne[0] == self.joueur:
                    self.nom = ligne[0]
                    self.score1 = ligne[1]        # nombre de parties gagnées
                    self.score2 = ligne[2]        # nombre de parties jouées
                    self.score3 = ligne[3]        # points : nombre d'essais non utilisés

        fichier1.close()
        #Affichage
        self.textNom = StringVar()
        self.textScore1 = StringVar()
        self.textScore2 = StringVar()
        self.textScore3 = StringVar()

        self.frameScore = Frame(self, bg='#b69f93')
        self.frameScore.grid(row=1, column=2, sticky='NE')
        self.afficherScore()
        self.groupeScore = LabelFrame(self.frameScore, text=self.nom,
            bg='#b69f93', font="Arial 10 bold", bd=5, relief=RIDGE, padx=10, pady=10)
        self.groupeScore.grid(row=0, column=0)

        self.labelScore1 = Label(self.groupeScore, textvariable=self.textScore1,
            bg='#b69f93', font="Arial 10 bold")
        self.labelScore1.grid(row=1, column=1, sticky='E')
        self.labelScore2 = Label(self.groupeScore, textvariable=self.textScore2,
            bg='#b69f93', font="Arial 10 bold")
        self.labelScore2.grid(row=2, column=1, sticky='E')
        self.labelScore3 = Label(self.groupeScore, textvariable=self.textScore3,
            bg='#b69f93', font="Arial 10 bold")
        self.labelScore3.grid(row=3, column=1, sticky='E')
        self.boutAband = Button(self.frameScore, text='Abandonnez et \nchoisir un autre joueur ?',
            font="Arial 10 bold", bd=0, fg='white', bg='#866752', command=self.abandonner)
        self.boutAband.grid(row=1, column=0, pady=25)
        self.frameDroite = Frame(self, width=200, height=750, bd=5, bg='#b69f93', relief=RIDGE)
        self.frameDroite.grid(row=1, column=1)
        self.canv0 = Canvas(self.frameGauche, bg='white', bd=3, height=50,
            width=200, relief=RIDGE)        # canv0 est le canvas recevant le tirage de l'ordinateur
        self.canv0.grid(row=0, column=0)
        self.listeCanvas = ['self.canv1', 'self.canv2', 'self.canv3',
            'self.canv4', 'self.canv5', 'self.canv6', 'self.canv7',
            'self.canv8', 'self.canv9', 'self.canv10']

        for ii in range(0, 10):
            self.listeCanvas[ii] = Canvas(self.frameGauche, width=200, bg='#866752',
                height=50, bd=3, relief=RIDGE)
            self.listeCanvas[ii].grid(row=11 - ii,
                column=0)

        ##Radioboutons pour le choix des couleurs
        self.choixCouleur = StringVar()
        self.choixCouleur.set(listeCouleur[0])
        for nn in range(0, 8):
            self.bout = Radiobutton(self.frameDroite,
                             text=nomCouleur[nn],
                             font=mafonte,
                             #foreground=listeCouleur[nn],
                             variable=self.choixCouleur,
                             bg='#b69f93',
                             value=listeCouleur[nn])

            self.bout.grid(row=nn, column=1, sticky=W)

        self.ok = Button(self.frameGauche, text='Vérifier ?', bg='#b69f93',
            bd=0, foreground='white', font=mafonte, command=self.verification)
        self.ok.grid(row=12, column=0, pady=10)

        self.tirageOrdi()
        listeAffichage[0] = choixJoueur(0, self)

    def abandonner(self):
        self.menu1 = Menu()
        self.destroy()

    def afficherScore(self):
        self.textScore1.set("Parties gagnées : " + str(self.score1))
        self.textScore2.set("Parties jouées : " + str(self.score2))
        #self.scoreEssais= int(self.score3) +self.nombreVerif
        self.textScore3.set("Points : " + str(self.score3))

    def verification(self):
        halt = 0
        if 0 not in listeAffichage[self.nombreVerif].listeChoixCouleur:
            listtest=list(self.listTirageCouleur)
            bon, mal=0, 0
            for tt in range (4):
                if listeAffichage[self.nombreVerif].listeChoixCouleur[tt]==listtest[tt]:
                    bon+=1
                    listeAffichage[self.nombreVerif].listeChoixCouleur[tt]="Bon"
                    listtest[tt]="Bon"

            if listeAffichage[self.nombreVerif].listeChoixCouleur.count('Bon')==4:

                halt=1
                self.score1=int(self.score1)+1
                self.score2=int(self.score2)+1
                self.score3=int(self.score3)+(10-self.nombreVerif)
                self.enregistrer()
                self.afficherScore()
                Label(self.frameScore, text='GAGNE', font='Arial 20 bold').grid (row=4, column=0, pady=50)
                x=25
                for n in range(4):
                    cercle(self.canv0, x, 25, 10, self.listTirageCouleur[n])
                    x+=25
                self.ok.destroy()
                self.recom=Button(self.frameGauche, text="Recommencer ?", bg='#b69f93', font=mafonte, command=self.recommencer)
                self.recom.grid(row=12, column=0, pady=10)

            if self.nombreVerif>=9 and halt==0:
                halt=1
                self.score2=int(self.score2)+1
                self.enregistrer()
                self.afficherScore()
                Label(self.frameScore, text='PERDU', font='Arial 20 bold').grid (row=4, column=0, pady=50)
                x=25
                for n in range(4):
                    cercle(self.canv0, x, 25, 10, self.listTirageCouleur[n])
                    x+=25
                self.ok.destroy()
                self.recom=Button(self.frameGauche, text='recommencer ?', font=mafonte, bg='#b69f93', command=self.recommencer)
                self.recom.grid(row=12, column=0, pady=10)

            for idd in range (1, bon+1):
                self.listeCanvas[self.nombreVerif].itemconfig(4+idd,  fill='black')
            for mm in range (4):
                if listeAffichage[self.nombreVerif].listeChoixCouleur[mm]!= "Bon":
                    if listeAffichage[self.nombreVerif].listeChoixCouleur[mm] in listtest:
                        mal+=1
                        i=listtest.index(listeAffichage[self.nombreVerif].listeChoixCouleur[mm]) #récupère l'index dans la liste listeChoixCouleur
                        listeAffichage[self.nombreVerif].listeChoixCouleur[mm]="Mal"
                        listtest[i]="Mal"
            for iddd in range (bon+1, bon+1+mal):
                self.listeCanvas[self.nombreVerif].itemconfig(4+iddd,  fill='white')
            self.nombreVerif+=1  #augmente de 1 l'index correspond aux Canevas


            if halt==0 and self.nombreVerif<=9:
                listeAffichage[self.nombreVerif]=choixJoueur(self.nombreVerif, self)
                self.listeCanvas[self.nombreVerif-1].configure(state=DISABLED)

    def recommencer(self):
        self.destroy()
        self.plateau = Plateau(self.nom)

    def enregistrer(self):
        with open(fic_score, 'r', newline='') as fichier1:
            lire = csv.reader(fichier1, delimiter=';')
            monfichier = []
            for ligne in lire:
                if ligne[0] == self.nom:

                    ligne[1] = self.score1
                    ligne[2] = self.score2
                    ligne[3] = self.score3
                monfichier.append(ligne)

        with open(fic_score, 'w', newline='') as fichier1:
            ecrire = csv.writer(fichier1, delimiter=';')
            for ligne in monfichier:
                ecrire.writerow(ligne)

    def tirageOrdi(self):
            x = 25
            self.listTirageCouleur = []
            for n in range(4):

                c = randrange(8)
                self.listTirageCouleur.append(listeCouleur[c])
                x+=25



class choixJoueur(Canvas):
    def __init__(self, indice, boss):
        Canvas.__init__(self, boss)
        self.ind = indice
        self.listeChoixCouleur = [0, 0, 0, 0]
        self.boss = boss
        x = 25
        for ind in range(4):
            tg = 'tg' + str(ind)
            cercle(self.boss.listeCanvas[self.ind], x, 27, 10, 'grey', tg)
            x += 25
        x = 150
        for ind in range(2):
            tg = 'tg' + str(ind)
            cercle(self.boss.listeCanvas[self.ind], x, 18, 3, 'grey', tg)
            x += 25

        x = 150
        for ind in range(2):
            tg = 'tg'+ str(ind)
            cercle(self.boss.listeCanvas[self.ind], x, 43, 3, 'grey', tg)
            x += 25
        self.boss.listeCanvas[self.ind].bind('<ButtonPress-1>', self.mouseDown)

    def mouseDown(self, event):
        self.x1, self.y1 = event.x, event.y
        self.selObject = self.boss.listeCanvas[self.ind].find_closest(self.x1, self.y1)
        if self.selObject[0] < 5:
            self.listeChoixCouleur[self.selObject[0]-1] = self.boss.choixCouleur.get()
            self.boss.listeCanvas[self.ind].itemconfig(self.selObject,  fill=self.boss.choixCouleur.get())


class Menu(Frame):
    def __init__(self):
        Frame.__init__(self)
        #Crée une copie de sauvegarde du fichier des noms et du score
        shutil.copy2(fic_score, fic_scoreOld)
        self.grid()

        self.configure(bg='#b69593')
        self.cadreTitre = Frame(self, bd=0, bg='#b69593')
        self.cadreTitre.grid(row=0, column=0, columnspan=3)
        self.canTitre = Canvas(self.cadreTitre, bd=0, bg='#b69593', height=110, width=410,
            highlightthickness=0)
        self.canTitre.grid()
        self.titre = PhotoImage(file=fic_image)
        self.canTitre.create_image(205, 55, anchor="center", image=self.titre)

        self.cadre1 = Frame(self, relief=RIDGE, padx=10, pady=10, bg='#866752')
        self.cadre1.grid(row=1, column=1)
        self.cadre1.columnconfigure(0, weight=1)
        self.cadre1.columnconfigure(1, weight=1)
        #canvas recevant les widgets du bas à gauche
        self.cadreListe = Canvas(self.cadre1, bd=4, )
        self.cadreListe.grid(row=0, column=0)
        #self.mesrectangle(self.cadreListe)
        Label(self.cadreListe, text='Choisissez votre nom\ndans la liste des joueurs :',
            font="Arial 10 bold", fg='white', bg='#866752').grid(row=0, column=0,
            columnspan=2, sticky='N')
        Button(self.cadreListe, text='Commencer', bg='#b69f93',
            font="Arial 10 bold", command=self.lancer, bd=0,
            foreground='white').grid(row=3, column=0, pady=10, columnspan=2)
        Button(self.cadreListe, text='Supprimer le joueur ', bg='#b69f93',
            font="Arial 8 bold", command=self.supp_joueur, bd=0,
            foreground='white').grid(row=4, column=0, pady=10, columnspan=2)
        scrollbar = Scrollbar(self.cadreListe, orient=VERTICAL)
        self.listeJoueur = Listbox(self.cadreListe, yscrollcommand=scrollbar.set,
            selectmode=SINGLE)
        scrollbar.config(command=self.listeJoueur.yview)
        scrollbar.grid(row=1, column=1, sticky="WNS")
        self.listeJoueur.grid(row=1, column=0, sticky="E")

        with open(fic_score, 'r', newline='') as fichier1:
            lire = csv.reader(fichier1, delimiter=';')
            for ligne in lire:
                self.listeJoueur.insert(END, ligne[0])

        self.listeJoueur.selection_set(first=0)

        self.cadre2 = Frame(self, padx=10, pady=10, bg='#866752')
        self.cadre2.grid(row=1, column=3, sticky="NE")
        self.cadre21 = Frame(self.cadre2)
        self.cadre21.grid(row=3, column=1, pady=5)
        Label(self.cadre2, text='Ou créez \nun nouveau joueur :', font="Arial 10 bold",
            fg='white', bg='#866752').grid(row=0, column=1, pady=5)
        Label(self.cadre2, text='Entrez un nom :', font="Arial 10 bold", fg='white',
            bg='#866752').grid(row=1, column=1, pady=5)
        self.entreNom = Entry(self.cadre21, font="Arial 10 bold", width=10, relief=FLAT)
        self.entreNom.grid(row=2, column=1, padx=5, pady=5)
        Button(self.cadre21, text='Créer', bg='#b69f93', font="Arial 10 bold",
            command=self.creer, bd=0, foreground='white').grid(row=3, column=1, padx=30, pady=10)

    def supp_joueur(self):

        choix = self.listeJoueur.curselection()

        with open(fic_score, 'r', newline='') as fichier1:
            lire = csv.reader(fichier1, delimiter=';')
            monfichier = []
            for ligne in lire:
                monfichier.append(ligne)

        with open(fic_score, 'w', newline='') as fichier1:
            ecrire = csv.writer(fichier1, delimiter=';')

            for ligne in monfichier:
                if not ligne[0].startswith(self.listeJoueur.get(choix)):
                    ecrire.writerow(ligne)
        self.listeJoueur.delete(0, END)
        with open(fic_score, 'r', newline='') as fichier1:
            lire = csv.reader(fichier1, delimiter=';')
            for ligne in lire:
                self.listeJoueur.insert(END, ligne[0])

        self.listeJoueur.selection_set(first=0)



    def lancer(self):
        choix = self.listeJoueur.curselection()
        if (len(choix)) == 0:
            message = Toplevel(self)
            X = fen.winfo_screenwidth()
            Y = fen.winfo_screenheight()
            w = 250
            h = 150
            X = (X - w) / 2
            Y = (Y - h) / 2
            message.geometry('%dx%d+%d+%d' % (w, h, X, Y))
            message.configure(bg='#b69593')
            Label(message, text='\nATTENTION \n\nVous devez créer un nom !\n de joueur',
                font="Arial 10 bold", fg='white', bg='#866752').pack()
            bout1 = Button(message, text='  OK  ', font="Arial 10 bold",
                bd=0, foreground='white', command=message.destroy, bg='#866752')
            bout1.pack(pady=10)
            message.transient(self)
            self.entreNom.focus_set()  # on donne le focus a l'Entry
        else:
            self.plateau = Plateau(self.listeJoueur.get(choix))
            self.destroy()

    def creer(self):
        if len(self.entreNom.get()) == 0 or len(self.entreNom.get()) > 8:
            message = Toplevel(self)

            X = fen.winfo_screenwidth()
            Y = fen.winfo_screenheight()
            w = 250
            h = 150
            X = (X - w) / 2
            Y = (Y - h) / 2
            message.geometry('%dx%d+%d+%d' % (w, h, X, Y))
            message.configure(bg='#b69593')
            Label(message, text='\nATTENTION \n\nVous devez entrer un nom !\n de 1 à 8 lettres',
                font="Arial 10 bold", fg='white', bg='#866752').pack()
            bout1 = Button(message, text='  OK  ', font="Arial 10 bold",
                bd=0, foreground='white', command=message.destroy, bg='#866752')
            bout1.pack(pady=10)
            message.transient(self)
        else:
            with open('ScoreMastermind.csv', 'a', newline='') as fichier1:
                ecrire = csv.writer(fichier1, delimiter=';')
                ecrire.writerow((self.entreNom.get(), 0, 0, 0))

            self.plateau = Plateau(self.entreNom.get())
            self.destroy()


if __name__ == '__main__':
    fen = Tk()
    fen.title('Mon MasterMind')
    #Centre la fenêtre:
    X = fen.winfo_screenwidth()
    Y = fen.winfo_screenheight()
    w = 600
    h = 750
    X = (X - w) / 2
    Y = (Y - h) / 2
    fen.geometry('%dx%d+%d+%d' % (w, h, X, Y))
    fen.configure(bg='#b69593')

    menu1 = Menu()
    fen.mainloop()
